-- TrackItemsWindow.lua
-- Written by Habna


local player = Turbine.Gameplay.LocalPlayer.GetInstance();
local backpack = player:GetBackpack();
local size = backpack:GetSize();

function frmTrackItemsWindow()
	frmTI = true;
	wTrackItems = Turbine.UI.Lotro.Window();
	--wTrackItems = Turbine.UI.Lotro.GoldWindow();
	
	wTrackItems:SetWidth( 390 );
    wTrackItems:SetPosition( BIWLeft, BIWTop );
	wTrackItems:SetText( L["BIIL"] );
	wTrackItems:SetVisible( true );
	wTrackItems:SetWantsKeyEvents( true );
	--wTrackItems:SetZOrder( 2 );
	wTrackItems:Activate();

	wTrackItems.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			wTrackItems:Close();
		elseif ( args.Action == 268435635 ) or ( args.Action == 268435579 ) then -- Hide if F12 key is press or reposition UI
			wTrackItems:SetVisible( not wTrackItems:IsVisible() );
		end
	end

	wTrackItems.MouseUp = function( sender, args )
		settings.BagInfos.L = string.format("%.0f", wTrackItems:GetLeft());
		settings.BagInfos.T = string.format("%.0f", wTrackItems:GetTop());
		BIWLeft, BIWTop = wTrackItems:GetPosition();
		SaveSettings( false );
	end

	wTrackItems.Closing = function( sender, args )
		wTrackItems:SetWantsKeyEvents( false );
		wTrackItems = nil;
		frmTI = nil;
	end
	
	wTrackItems.lblBackPack = Turbine.UI.Label();
	wTrackItems.lblBackPack:SetParent( wTrackItems );
	wTrackItems.lblBackPack:SetText( L["BIT"] );
	wTrackItems.lblBackPack:SetPosition( 0, 35);
	wTrackItems.lblBackPack:SetSize( wTrackItems:GetWidth() , 15 );
	wTrackItems.lblBackPack:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	wTrackItems.lblBackPack:SetForeColor( Color["green"] );

	-- **v search label & text box v**
	wTrackItems.searchLabel = Turbine.UI.Label();
    wTrackItems.searchLabel:SetParent( wTrackItems );
    wTrackItems.searchLabel:SetText( L["VTSe"] );
    wTrackItems.searchLabel:SetPosition( 15, 60 );
    wTrackItems.searchLabel:SetSize( wTrackItems.searchLabel:GetTextLength() * 8, 18 ); --Auto size with text lenght
    wTrackItems.searchLabel:SetFont( Turbine.UI.Lotro.Font.TrajanPro15 );
    wTrackItems.searchLabel:SetForeColor( Color["gold"] );
	 
    wTrackItems.SearchTextBox = Turbine.UI.Lotro.TextBox();
    wTrackItems.SearchTextBox:SetParent( wTrackItems );
    wTrackItems.SearchTextBox:SetPosition(  wTrackItems.searchLabel:GetLeft() +  wTrackItems.searchLabel:GetWidth(),  wTrackItems.searchLabel:GetTop() );
    wTrackItems.SearchTextBox:SetSize( wTrackItems:GetWidth() - 150, 18 );
    wTrackItems.SearchTextBox:SetFont( Turbine.UI.Lotro.Font.Verdana14 );
	wTrackItems.SearchTextBox:SetMultiline( false );
	
    wTrackItems.SearchTextBox.TextChanged = function( sender, args )
        wTrackItems.searchText = string.lower( wTrackItems.SearchTextBox:GetText() );
        if wTrackItems.searchText == "" then wTrackItems.searchText = nil; end
        ShowStackableItems();
    end

	wTrackItems.SearchTextBox.FocusLost = function( sender, args )
		
	end
	-- **^
	--**v clear search text box icon v**
	wTrackItems.DelIcon = Turbine.UI.Label();
	wTrackItems.DelIcon:SetParent( wTrackItems );
	wTrackItems.DelIcon:SetPosition( wTrackItems.SearchTextBox:GetLeft() + wTrackItems.SearchTextBox:GetWidth() + 5, wTrackItems.SearchTextBox:GetTop() );
	wTrackItems.DelIcon:SetSize( 16, 16 );
	wTrackItems.DelIcon:SetBackground( 0x4101f893 );
	wTrackItems.DelIcon:SetBlendMode( 4 );
	wTrackItems.DelIcon:SetVisible( true );
				
	wTrackItems.DelIcon.MouseClick = function( sender, args )
		wTrackItems.SearchTextBox:SetText( "" );
		wTrackItems.SearchTextBox.TextChanged( sender, args );
		wTrackItems.SearchTextBox:Focus();
	end
	-- **^
	-- **v Set the item listbox border v**
	wTrackItems.ListBoxBorder = Turbine.UI.Control();
	wTrackItems.ListBoxBorder:SetParent( wTrackItems );
	wTrackItems.ListBoxBorder:SetWidth( wTrackItems:GetWidth() - 30 );
	wTrackItems.ListBoxBorder:SetBackColor( Color["grey"] );
	-- **^
	-- **v Set the item listbox v**
	wTrackItems.ListBox = Turbine.UI.ListBox();
	wTrackItems.ListBox:SetParent( wTrackItems );
	wTrackItems.ListBox:SetWidth( wTrackItems.ListBoxBorder:GetWidth() - 4 );
	wTrackItems.ListBox:SetMaxItemsPerLine( 1 );
	wTrackItems.ListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	wTrackItems.ListBox:SetBackColor( Color["black"] );
	-- **^
	-- **v Set the listbox scrollbar v**
	wTrackItems.ListBoxScrollBar = Turbine.UI.Lotro.ScrollBar();
	wTrackItems.ListBoxScrollBar:SetParent( wTrackItems.ListBox );
	wTrackItems.ListBoxScrollBar:SetPosition( wTrackItems.ListBox:GetWidth() - 10, 0 );
	wTrackItems.ListBoxScrollBar:SetWidth( 12 );
	wTrackItems.ListBoxScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
	wTrackItems.ListBox:SetVerticalScrollBar( wTrackItems.ListBoxScrollBar );
	-- **^

	CheckForStackableItems();
end

function CheckForStackableItems()
	item = {};
	itemCtl = {};
	itemLbl = {};
	bFound = false;

	for i = 1, size do
		item[i] = backpack:GetItem( i );
		if item[i] ~= nil then
			local iteminfo = item[i]:GetItemInfo();
			item[i].Name = iteminfo:GetName();
			if iteminfo:GetMaxStackSize() > 1 then
				bFound = true
				item[i].Stackable = true;
			else
				item[i].Stackable = false;
			end
		else
			item[i] = "zEmpty";
		end
	end
	
	if bFound then ShowStackableItems();
	else SetEmptyTrackList(); end
end

function SetEmptyTrackList()
	itemCtl = Turbine.UI.Control();
	itemCtl:SetSize( wTrackItems.ListBox:GetWidth(), 35 );

	local lblmgs = Turbine.UI.Label();
	lblmgs:SetParent( itemCtl );
	lblmgs:SetText( L["BIMsg"] );
	lblmgs:SetPosition( 0, 0 );
	lblmgs:SetSize( itemCtl:GetWidth(), itemCtl:GetHeight() );
	lblmgs:SetForeColor( Color["red"] );
	lblmgs:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );

	wTrackItems.ListBoxBorder:SetPosition( 15, 60 );
	wTrackItems.ListBoxBorder:SetHeight( lblmgs:GetHeight() + 4 );
	wTrackItems.ListBox:SetPosition( wTrackItems.ListBoxBorder:GetLeft() + 2, wTrackItems.ListBoxBorder:GetTop() + 2 );
	wTrackItems.ListBox:SetHeight( lblmgs:GetHeight() );
	wTrackItems.ListBoxScrollBar:SetVisible( false );

	wTrackItems.ListBox:AddItem( itemCtl );
	wTrackItems:SetHeight( itemCtl:GetHeight() + 85 );
end

function ShowStackableItems()
	wTrackItems.ListBox:ClearItems();

	for i = 1, size do
		if item[i] ~= "zEmpty" and item[i].Stackable then -- Only show stackable item
			if not wTrackItems.searchText or string.find(string.lower( item[i].Name ), wTrackItems.searchText, 1, true) then
				-- Item control
				itemCtl[i] = Turbine.UI.Control();
				itemCtl[i]:SetSize( wTrackItems.ListBox:GetWidth() - 10, 35 );

				-- Item Background/Underlay/Shadow/Image
				local itemBG = Turbine.UI.Lotro.ItemControl( item[i] );
				itemBG:SetParent( itemCtl[i] );
				itemBG:SetSize( 34, 34 );
				itemBG:SetPosition( 0, 0 );

				-- Item name
				itemLbl[i] = Turbine.UI.Label();
				itemLbl[i]:SetParent( itemCtl[i] );
				itemLbl[i]:SetSize( wTrackItems.ListBox:GetWidth() - 48, 33 );
				itemLbl[i]:SetPosition( 36, 3 );
				itemLbl[i]:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 );
				itemLbl[i]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
				itemLbl[i]:SetBackColorBlendMode( 5 );
				itemLbl[i]:SetForeColor( Color["white"] );
				itemLbl[i]:SetText( item[i].Name );
				itemLbl[i].Sel = false;

				itemLbl[i].MouseClick = function( sender, args )
					if ( args.Button == Turbine.UI.MouseButton.Left ) then
						if not itemLbl[i].Sel then
							itemLbl[i].Sel = true;
							itemLbl[i]:SetForeColor( Color["green"] );

							local tITL = {};
							local iteminfo = item[i]:GetItemInfo();
							tITL[item[i].Name] = {};
							tITL[item[i].Name].Q = tostring(iteminfo:GetQualityImageID());
							tITL[item[i].Name].B = tostring(iteminfo:GetBackgroundImageID());
							tITL[item[i].Name].U = tostring(iteminfo:GetUnderlayImageID());
							tITL[item[i].Name].S = tostring(iteminfo:GetShadowImageID());
							tITL[item[i].Name].I = tostring(iteminfo:GetIconImageID());
							table.insert( ITL, tITL );
							
							SavePlayerItemTrackingList(ITL);

							--Check all listbox for identical item name
							for ii = 1, size do
								if item[ii] ~= "zEmpty" and item[ii].Stackable then
									if ii ~= i then
										if item[ii].Name == itemLbl[i]:GetText() then
											itemLbl[ii]:SetForeColor( Color["green"] );
											itemLbl[ii]:SetBackColor( Color["darkgrey"] );
											itemLbl[ii].Sel = true;
										end
									end
								end
							end
						else
							itemLbl[i].Sel = false;
							itemLbl[i]:SetForeColor( Color["white"] );

							local iFoundAt = 0;
							for ii = 1, #ITL do
								for k, v in pairs(ITL[ii]) do
									if k == itemLbl[i]:GetText() then iFoundAt = ii; break end
								end
							end
						
							table.remove( ITL, iFoundAt );
							SavePlayerItemTrackingList(ITL)

							--Check all listbox for identical item name
							for ii = 1, size do
								if item[ii] ~= "zEmpty" and item[ii].Stackable then
									if ii ~= i then
										if item[ii].Name == itemLbl[i]:GetText() then
											itemLbl[ii]:SetForeColor( Color["white"] );
											itemLbl[ii]:SetBackColor( Color["black"] );
											itemLbl[ii].Sel = false;
										end
									end
								end
							end
						end
					end
				end

				itemLbl[i].MouseHover = function(sender, args)
					itemLbl[i]:SetBackColor( Color["lightgrey"] );
				end

				itemLbl[i].MouseLeave = function(sender, args)
					if itemLbl[i].Sel then itemLbl[i]:SetBackColor( Color["darkgrey"] ); else itemLbl[i]:SetBackColor( Color["black"] ); end
				end

				wTrackItems.ListBox:AddItem( itemCtl[i] );
			end
		end
	end
	
	for i = 1, #ITL do
		for k, v in pairs(ITL[i]) do
			for ii = 1, size do
				if item[ii] ~= "zEmpty" and item[ii].Stackable then
					if k == itemLbl[ii]:GetText() then
						itemLbl[ii]:SetForeColor( Color["green"] );
						itemLbl[ii]:SetBackColor( Color["darkgrey"] );
						itemLbl[ii].Sel = true;
					end
				end
			end
		end
	end

	wTrackItems.ListBoxBorder:SetPosition( 15, wTrackItems.SearchTextBox:GetTop() + wTrackItems.SearchTextBox:GetHeight() + 5 );
	wTrackItems.ListBoxBorder:SetHeight( 392 );
	wTrackItems.ListBox:SetPosition( wTrackItems.ListBoxBorder:GetLeft() + 2, wTrackItems.ListBoxBorder:GetTop() + 2 );
	wTrackItems.ListBox:SetHeight( wTrackItems.ListBoxBorder:GetHeight() - 4 );
	wTrackItems.ListBoxScrollBar:SetHeight( wTrackItems.ListBox:GetHeight() );
	wTrackItems:SetHeight( 498 );
end